/* /////////////////////////////////////////////////////////////////////////////////////////////////

Author: PluginIdea
Email:sugamer8 @gmail.com
Patreon:https://www.patreon.com/PluginIdea

©2022 PluginIdea, Inc.All rights reserved.

///////////////////////////////////////////////////////////////////////////////////////////////// */

using UnityEngine;using System.Collections;using UnityEngine.Video;using UnityEngine.UI;using System.Linq;using System;using MVR.FileManagement;using System.Collections.Generic;namespace PluginIdea.MovePoseHolder{class MovePoseHolder : MVRScript{private const string EmbodyActive = "Active";private JSONStorableBool isAlwaysSync;private Vector3 offset;private FreeControllerV3 headController;private bool isFree = true;public override void Init(){Location.InitTData();DataInit();UIInit();}private bool IsOnPosses{get{bool isOnSelectMode = SuperController.singleton.currentSelectMode == SuperController.SelectMode.Possess;bool isEmbodyActive = false;var t = Utils.GetPluginStorable(containingAtom, "Embody");if (t != null){try{isEmbodyActive = t.GetBoolParamValue(EmbodyActive);}catch (Exception){}}return isOnSelectMode || isEmbodyActive;}}private void DataInit(){if (!Utils.IsInVR()){SuperController.LogError(Location.GetStr(Location.NoVR));enabled = false;return;}headController = GetAllControllers().ToList().FirstOrDefault(x => x.name == "headControl");if (headController == null){SuperController.LogError(Location.GetStr(Location.NeedOnPerson));return;}RecordOffset();}private void RecordOffset(){offset = (containingAtom.mainController.transform.position - headController.transform.position);}private void UIInit(){if (isFree){var btn = Utils.CreateButton(this, Location.GetStr(Location.OpenMainPage), () =>{if (Location.IsChinease) Application.OpenURL(@"https:\/\/afdian.net/a/PluginIdea");else Application.OpenURL(@"https:\/\/www.patreon.com/PluginIdea");}, false, true);btn.buttonImage.color = Color.yellow;Utils.CreateSpacer(this, 30, false);}Utils.CreateInfoText(this, Location.GetStr(Location.PluginInfo), 400, true);Utils.CreateButton(this, Location.GetStr(Location.Reset), () =>{RecordOffset();}, false, true);isAlwaysSync = Utils.CreateToggle(this, Location.GetStr(Location.AlwaysSync), false, false, true);}private void LateUpdate(){if (Utils.IsInVR() && IsOnPosses){Vector4 freeNavigateVector = SuperController.singleton.GetFreeNavigateVector(SuperController.singleton.freeMoveAction);freeNavigateVector.x = Mathf.Abs(freeNavigateVector.x);freeNavigateVector.y = Mathf.Abs(freeNavigateVector.y);if (freeNavigateVector.x > 0.001f || freeNavigateVector.y > 0.001f || freeNavigateVector.z > 0.001f || freeNavigateVector.w > 0.001f || isAlwaysSync.val){containingAtom.mainController.transform.position = headController.transform.position + offset;}Transform mainControlTrans = containingAtom.mainController.transform;if (freeNavigateVector.z > 0.01f || freeNavigateVector.z < -0.01f || isAlwaysSync.val){mainControlTrans.RotateAround(mainControlTrans.position, Vector3.up, freeNavigateVector.z * 50f * Time.unscaledDeltaTime);}}}}}